// 選択されているテキストオブジェクトを取得する
var selectedItems = app.activeDocument.selection;

// 選択された各テキストオブジェクトに対して処理を行う
for (var j = 0; j < selectedItems.length; j++) {
    var textItem = selectedItems[j];

    // テキストを文字ごとに分解する
    var textRanges = textItem.textRanges;
    var characters = [];

    for (var k = 0; k < textRanges.length; k++) {
        var range = textRanges[k];
        var rangeCharacters = range.characters;

        for (var i = 0; i < rangeCharacters.length; i++) {
            var character = rangeCharacters[i];
            characters.push(character);
        }
    }

    // 元のテキストオブジェクトのプロパティを取得する
    var originalX = textItem.position[0];
    var originalY = textItem.position[1];
    var originalFontSize = textItem.textRange.characterAttributes.size;
    var originalFont = textItem.textRange.characterAttributes.textFont;
    var originalLeading = textItem.textRange.characterAttributes.leading;
    var originalFillColor = textItem.textRange.characterAttributes.fillColor;

    // 新しいテキストフレームを作成する
    var newFrames = [];

    // 元のテキストフレームの内容を分割した新しいテキストフレームに代入する
    for (var i = 0; i < characters.length; i++) {
        var character = characters[i].contents;

        // 新しいテキストフレームを作成し、文字を代入する
        var parentFrame = textItem.parent;
        var newFrame = parentFrame.textFrames.add();
        newFrame.contents = character;

        // プロパティを設定して元のテキストオブジェクトと同じスタイルを維持する
        newFrame.position = [originalX + (i * originalFontSize), originalY];
        newFrame.textRange.characterAttributes.size = originalFontSize;
        newFrame.textRange.characterAttributes.textFont = originalFont;
        newFrame.textRange.characterAttributes.leading = originalLeading;
        newFrame.textRange.characterAttributes.fillColor = originalFillColor;

        // 新しいテキストフレームを配列に追加する
        newFrames.push(newFrame);
    }

    // 元のテキストフレームを削除する
    textItem.remove();
}
